/*
 * RestrictedTextField v1.4
 * https://www.github.com/kloverde/jquery-RestrictedTextField
 *
 * Copyright (c) 2016, Kurtis LoVerde
 * All rights reserved.
 *
 * Donations:  https://paypal.me/KurtisLoVerde/10
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     1. Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *     2. Redistributions in binary form must reproduce the above copyright
 *        notice, this list of conditions and the following disclaimer in the
 *        documentation and/or other materials provided with the distribution.
 *     3. Neither the name of the copyright holder nor the names of its
 *        contributors may be used to endorse or promote products derived from
 *        this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

!function(e){"use strict";function t(e,t,n,r){if(null==t||null==t)throw"id is undefined";if(!i(t,"String"))throw"id must be a string";if(t.length<1)throw"id is empty";if(null==n||null==n)throw"fullRegex is undefined";if(!i(n,"RegExp"))throw"fullRegex must be a RegExp object";if(null!=r&&null!=r&&!i(r,"RegExp"))throw"partialRegex must be a RegExp object";e[t]={fullRegex:n,partialRegex:r}}function n(e){return null==e||e.length<1}function i(e,t){var n=Object.prototype.toString.call(e).slice(8,-1);return null!=e&&n.toUpperCase()===t.toUpperCase()}e.fn.RestrictedTextFieldConfig=function(){var n=e.fn.RestrictedTextFieldConfig.customTypes=e.fn.RestrictedTextFieldConfig.customTypes||[];this.addType=function(e,i,r){t(n,e,i,r)}},e.fn.restrictedTextField=function(i){var r=e.extend({type:null,preventInvalidInput:!0,usePatternAttr:!1,logger:void 0},i),l="validationFailed",d="validationSuccess";if("input"!==this.prop("tagName").toLowerCase())throw"RestrictedTextField can only be invoked on an input element";if(!0===r.preventInvalidInput&&!0===r.usePatternAttr)throw"Invalid configuration:  preventInvalidInput and usePatternAttr cannot both be true";void 0!==e.fn.restrictedTextField.types&&null!==e.fn.restrictedTextField.types||function(){var n=/^-\d*$/,i=/^-?\d*\.?\d*$/,r=/^\d*\.?\d*$/,l=/^0*\.?$|^-\d*\.?\d*$/;void 0!==e.fn.restrictedTextField.types&&null!==e.fn.restrictedTextField.types||(e.fn.restrictedTextField.types=[]);var d=e.fn.restrictedTextField.types=e.fn.restrictedTextField.types||[];t(d,"alpha",/^[a-zA-Z]+$/,null),t(d,"upperAlpha",/^[A-Z]+$/,null),t(d,"lowerAlpha",/^[a-z]+$/,null),t(d,"alphaSpace",/^[a-zA-Z ]+$/,null),t(d,"upperAlphaSpace",/^[A-Z ]+$/,null),t(d,"lowerAlphaSpace",/^[a-z ]+$/,null),t(d,"alphanumeric",/^[a-zA-Z\d]+$/,null),t(d,"upperAlphanumeric",/^[A-Z\d]+$/,null),t(d,"lowerAlphanumeric",/^[a-z\d]+$/,null),t(d,"alphanumericSpace",/^[a-zA-Z\d ]+$/,null),t(d,"upperAlphanumericSpace",/^[A-Z\d ]+$/,null),t(d,"lowerAlphanumericSpace",/^[a-z\d ]+$/,null),t(d,"int",/^-?\d+$/,n),t(d,"positiveInt",/^\d+$/,null),t(d,"negativeInt",/^0+$|^-\d+$/,n),t(d,"strictInt",/^0+$|^-?0*[1-9]\d*$/,n),t(d,"strictPositiveInt",/^\d+$/,null),t(d,"strictNegativeInt",/^0+$|^-0*[1-9]\d*$/,n),t(d,"float",/^-?\d*\.?\d+$/,i),t(d,"positiveFloat",/^\d*\.?\d+$/,r),t(d,"negativeFloat",/^-?0+$|^-?0*\.?0+$|^-\d*\.?\d+$/,l),t(d,"strictFloat",/^0*\.0+$|^-?0*\.\d*[1-9]$|^-?\d*\.\d*[1-9]\d*$|^-?0*[1-9]\d*?\d*\.\d+$/,i),t(d,"strictPositiveFloat",/^0*\.0+$|^0*\.\d*[1-9]$|^\d*\.\d*[1-9]\d*$|^\d*[1-9]*\d*\.\d+$/,r),t(d,"strictNegativeFloat",/^0*\.0+$|^-0*\.\d*[1-9]$|^-\d*\.\d*[1-9]\d*$|^-[^0]\d*?\d*\.\d+$/,l),t(d,"money",/^-?\d+\.\d{2}$/,/^-?\d*\.?\d{0,2}$/),t(d,"positiveMoney",/^\d+\.\d{2}$/,/^\d*\.?\d{0,2}$/),t(d,"negativeMoney",/^0\.00$|^-\d+\.\d{2}$/,/^0*\.?0?$|^-\d*\.?\d{0,2}$/),t(d,"accountingMoney",/^\d*\.?\d{2}$|^\(\d*\.?\d{2}\)$/,/^\(?0*\.?0{0,2}$|^[\.\d]$|^\.$|^\d*\.\d{0,2}$|^\(\d*\.?$|^\(\d*\.\d{1,2}?\)?$/),t(d,"negativeAccountingMoney",/^0\.00$|^\(\d*\.?\d{2}\)$/,/^\(?0*\.?0{0,2}$|^\(\d*\.?$|^\((\d*\.\d{1,2}?)\)?$/),t(d,"americanExpress",/^3[47]\d{13}$/,/^3[47]?$|^3[47]\d{0,13}$/),t(d,"visa",/^4(\d{12}|\d{15}|\d{18})$/,/^4\d{0,18}$/),t(d,"masterCard",/^5[12345]\d{14}$|^(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)\d{12}$/,s(/^5([12345]?|[12345]\d{0,14})$/,/^2[2-7]?$/,/^(22[2-9]|2[3-6][0-9]|27[0-2])$/,/^(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)\d{0,12}$/)),t(d,"discover",/^6011(\d{12}|\d{15})$|^65(\d{14}|\d{17})$|^64[4-9](\d{13}|\d{16})$|^(62212[6-9]|6221[3-9][0-9]|622[2-8][0-9]{2}|6229[01][0-9]|62292[0-5])(\d{10}|\d{13})$/,s(/^60?$|^601?$|^6011?$|^6011\d{0,15}$/,/^622?$/,/^622[1-9]$/,/^(6221[2-9]|622[2-8][0-9]|6229[0-2])$/,/^(62212[6-9]|6221[3-9][0-9]|622[2-8][0-9]{2}|6229[01][0-9]|62292[0-5])(\d{0,10}|\d{0,13})$/,/^64?$|^64[4-9]\d{0,16}$/,/^6(5?|5\d{0,17})$/)),t(d,"creditCard",u(!0,"americanExpress","visa","masterCard","discover"),u(!1,"americanExpress","visa","masterCard","discover")),t(d,"luhnNumber",/^\d+$/,null),t(d,"usZip",/^\d{5}(-\d{1,4})?$/,/^(\d{1,5}|\d{5}-|\d{5}-\d{1,4})$/),t(d,"usZip5",/^\d{5}$/,/^\d{1,5}$/),t(d,"usZipSuffix",/^\d{1,4}$/,null)}();var a=e.fn.restrictedTextField.types[r.type];if(n(a)&&(void 0!==e.fn.RestrictedTextFieldConfig.customTypes&&null!==e.fn.RestrictedTextFieldConfig.customTypes&&(a=e.fn.RestrictedTextFieldConfig.customTypes[r.type]),n(a)))throw"Invalid type: "+r.type;function u(){if(arguments.length<3)throw"Minimum 3 arguments: boolean, id, id";for(var t=arguments[0],n=e.fn.restrictedTextField.types,i=new RegExp(t?n[arguments[1]].fullRegex:n[arguments[1]].partialRegex),r=2;r<arguments.length;r++)i=s(i,t?n[arguments[r]].fullRegex:n[arguments[r]].partialRegex);return i}function s(){if(arguments.length<2)throw"Minimum 2 RegExp arguments";for(var e=new RegExp(arguments[0]),t=1;t<arguments.length;t++)e=new RegExp(e.source+"|"+arguments[t].source);return e}return this.each(function(){var t=e(this),i="";if(!0===r.usePatternAttr){var u=a.fullRegex.toString();t.prop("pattern","/"===u[0]&&"/"===u[u.length-1]?u.substring(1,u.length-1):u)}else t.on("keydown paste",function(e){i=this.value}),t.on("input",function(t){o("caught input - new value: "+this.value);var n=e(this),u=!1,s=!1,p=r.preventInvalidInput?null:l;0===this.value.length?(u=!0,s=!0,r.preventInvalidInput||(p=d)):(s=a.fullRegex.test(this.value),void 0!==a.partialRegex&&null!==a.partialRegex&&(u=a.partialRegex.test(this.value)),s?(o("passes full regex"),r.preventInvalidInput||(p=d)):(o("fails full regex"),u?(o("passes partial regex"),r.preventInvalidInput||(p=d)):(o("fails partial regex"),r.preventInvalidInput||(p=l))),u||s||r.preventInvalidInput&&(p="inputIgnored",n.val(i),o('reverted field to "'+i+'"'))),null!=p&&(o("triggering "+p+" event "),n.trigger(p))});t.on("blur",function(){var e=r.type,i=!1,u=l;if(("money"!==e&&"positiveMoney"!==e&&"negativeMoney"!==e||isNaN(this.value))&&("accountingMoney"!==e&&"negativeAccountingMoney"!==e||isNaN(this.value.replace(/^\((.*)\)$/,"$1"))))"americanExpress"===e||"visa"===e||"masterCard"===e||"discover"===e||"creditCard"===e||"luhnNumber"===e?!1===r.usePatternAttr&&(i=a.fullRegex.test(this.value))&&o((i=function(e){var t=[],n=0,i=0;if(isNaN(e))throw"Value ["+e+"] is not numeric";for(var r=!0,l=e.length-2;l>=0;l--){var d=parseInt(e[l]);if(r){var a=2*d;t[l]=a>9?a-9:a}else t[l]=d;n+=t[l],r=!r}return(n+=i=9*n%10)%10==0&&parseInt(e[e.length-1])===i}(this.value))?"passes Luhn check":"fails Luhn check"):!1===r.usePatternAttr&&(i=a.fullRegex.test(this.value));else{var s=function(e){if(n(e))return e;var t=e,i=(o=e,e=o.replace(/^(-?\(?)0*(\d+\.\d+)/,"$1$2")).length,r="-"===e[0]?"-":"",l="("===e[0]?"(":"",d=")"===e[i-1]?")":"",a=e.indexOf("."),u=e.substring(""===l&&""===r?0:1,a>0?a-1:")"===d?i-1:i),s="00";var o;a>-1&&(u=e.substring(""===l&&""===r?0:1,a),s=e.substring(a+1,""===d?i:i-1));t=""!==u&&0!==parseInt(u)||0!==parseInt(s)?l+r+(""===u?"0":u)+"."+s+(1===s.length?"0":"")+d:"0.00";return t}(this.value);(i=a.fullRegex.test(s))&&(this.value=s,o("blur:  formatted "+r.type+" field to "+s))}!1===r.usePatternAttr&&((0===this.value.length||i)&&(u=d),o("triggering "+u+" event "),t.trigger(u))})});function o(e){r.logger&&"function"==typeof r.logger&&r.logger("jquery.restrictedtextfield.js:  "+e)}}}(jQuery);